Codeforces 455A Boredom【dp】

A. Boredom

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Alex doesn't like boredom. That's why whenever he gets bored, he comes up with games. One long winter evening he came up with a game and decided to play it.

Given a sequence a consisting of n integers. The player can make several steps. In a single step he can choose an element of the sequence (let's denote it ak) and delete it, at that all elements equal to ak + 1 and ak - 1 also must be deleted from the sequence. That step brings ak points to the player.

Alex is a perfectionist, so he decided to get as many points as possible. Help him.

Input

The first line contains integer n (1 ≤ n ≤ 105) that shows how many numbers are in Alex's sequence.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 105).

Output

Print a single integer — the maximum number of points that Alex can earn.

Examples

Input

2
1 2

Output

2

Input

3
1 2 3

Output

4

Input

9
1 2 1 3 2 2 2 2 3

Output

10

Note

Consider the third test example. At first step we need to choose any element equal to 2. After that step our sequence looks like this [2, 2, 2, 2]. Then we do 4 steps, on each step we choose any element equals to 2. In total we earn 10 points.


题目大意:

给你一个长度为N的一个序列,我们得到分数的操作是这样的:

当我们选择了一个数字Ai,我们取出Ai这个数的同时,获得Ai点分数,同时值为Ai-1和Ai+1的数全部消失,问我们一共最多能够获得多少分。


思路:


1、首先我们考虑一个极限思想,如果我们现在取出了一个数Ai,那么值为Ai-1和Ai+1的数会全部消失,那么我们剩下的Ai拿与不拿都不会继续影响最终的结果,那么如果我们拿了一个Ai,其实不放我们将所有的Ai都取出来。那么我们每一次拿一个数获得的点数为:这个数出现的次数*这个数的值。那么我们可以设定vis【i】表示第i个数出现的次数。


2、那么因为考虑的是取数而不是对应哪一个位子的数,那么我们设定dp【i】表示拿到第i个数,并且拿取i这个数获得的最大点数。那么我们不难确定一个dp方向:从第一个数开始取,一直取到100000这个数。

那么不难想到其状态转移方程:dp【i】=vis【i】*i+max(dp【z】)【1<=z<=i-2】,然而我们如果直接暴力判断从1到i-2的最大的dp【z】的值的时间复杂度为O(n^2),显然会超时,那么我们设定一个值maxn,来维护这个max(dp【z】);

那么我们确定算法过程:

①初始化dp【i】=0,maxn=0;

②从1扫到100000,dp【i】=vis【i】+maxn;

③maxn=max(dp【i-1】,maxn),这样当下一次进行dp的时候,这个maxn的值就是max(dp【z】)【1<=z<=i-2】了。


Ac代码:


#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
#define ll long long int
int a[100050];
ll vis[100050];
ll dp[100050];
int main()
{
    int n;
    while(~scanf("%d",&n))
    {
        memset(a,0,sizeof(a));
        memset(vis,0,sizeof(vis));
        for(int i=0;i<n;i++)
        {
            scanf("%d",&a[i]);
            vis[a[i]]++;
        }
        ll ans=0;
        ll maxn=0;
        memset(dp,0,sizeof(dp));
        for(int i=1;i<=100030;i++)
        {
            dp[i]=vis[i]*i+maxn;
            maxn=max(dp[i-1],maxn);
            ans=max(ans,dp[i]);
        }
        printf("%I64d\n",ans);
    }
}





  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值